/* Orion Lawlor's Short UNIX Examples, olawlor@acm.org 2003/8/18

Shows how to use the curses library to take control
of a terminal, and grab every key typed.

It's gotta be linked with "-lcurses".
*/
#include <stdio.h>
#include <curses.h>
#include <stdlib.h>
#include <string.h>

typedef void (*atExitType)();

int main(int argc,char *argv[])
{
	int c;
	
	/*Standard initialization code*/
	initscr();
	cbreak();
	noecho(); /* disable keyboard echo */
	nonl();
	//intrflush(stdscr,FALSE);
	keypad(stdscr,TRUE);
	atexit((atExitType)endwin);
	
	/*Event loop:*/
	while ((c=getch()) !=EOF)
	{
		if (c=='q') break;
		printw("Key hit: %c==%x==%d\n",(char)c,c,c);
	}
	printw("Done.\n");
}

/*<@>
<@> ******** Program output: ********
<@> (B)0[?1048h[?1047h[1;24r[m[4l[?7h[?1h=[H[2J
<@> Key hit:
[3d==a==10
[4d[24;1H[?1047l[?1048l
[?1l>
<@> */
